const utils = require("../templateUtils");

module.exports = data =>
  `// this file contains a test harness that was auto-generated by fastify-swaggergen
// running the tests directly after generation will probably fail as the parameters
// need to be manually added.

const t = require("tap");
const test = t.test;
const Fastify = require("fastify");
const fastifyPlugin = require("../${data.plugin}");

const swaggerSpec = "../${data.specFile}";
const service = require("../${data.service}");

const opts = {
  swaggerSpec,
  service
};

${data.routes
    .map(
      route => `
// Operation: ${route.operationId}
// URL: ${route.url}
// summary:  ${route.schema.summary}
${utils.comments(route)}

test("testing ${route.operationId}", t => {
  t.plan(2);
  const fastify = Fastify();
  fastify.register(fastifyPlugin, opts);

  fastify.inject(
    {
      method: "${route.method}",
      url: "${data.generic.basePath ? data.generic.basePath : ""}${route.url}",
      payload: undefined, ${
        route.schema.body ? `//insert body data here!!` : ""
      }
      headers: undefined ${
        route.schema.headers ? `//insert headers here!!` : ""
      }
    },
    (err, res) => {
      t.error(err);
      t.strictEqual(res.statusCode, 200);
    }
  );
});

`
    )
    .join("\n")}`;
